#pragma once

#include <string>
#include <filesystem>
#include "glad/glad.h"
#include <LearnOpenGL/Texture.h>

namespace LearnOpenGL {

    enum class TextureWrapMode
    {

    };

    enum class TextureFilterMode
    {

    };

    // Texture2D is able to store and configure a texture in OpenGL
    // It also hosts utility functions for easy management.
    class Texture2D : public Texture {
    public: // Member Data
        unsigned int ID; // ID of the texture object
        unsigned int SlotID; // ID of the graphics texture unit slot
        unsigned int Width, Height;
        unsigned int InternalFormat;
        unsigned int ImageFormat;
        unsigned int WrapS;
        unsigned int WrapT;
        unsigned int Filter_Min;
        unsigned int Filter_Max;

        std::string Type;
        std::string Path;
    public: // Functions
        Texture2D();

        static Texture2D LoadFromFilepath(const std::filesystem::path& resource);
        static Texture2D LoadFromPixelDataBuffer(uint8_t* data);

        void Generate(unsigned int width, unsigned int height, unsigned char *data);



        void SetVertWrapMode();
        void SetHorizWrapMode();

        void SetVertFilterMode();
        void SetHorizFilterMode();



        void Bind();
        void Unbind();
        inline GLuint getTextureHandle() const { return ID;}
    protected:
    private:
        bool isBound;
    };
}